using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;
using Path;    //namespace interno a path.dll

namespace Test
{


public delegate void selectRectEventHandler
  (object sender, selectRectEventArgs e);

public class selectRectEventArgs : EventArgs
{
  public Point p1;
  public Point p2;

  public selectRectEventArgs(Point p, Point q)
  {
	this.p1 = p;
	this.p2 = q;
  }
}
	/// <summary>
	/// Rectangle class for 2d mouse selection.
	/// </summary>
	public class SelectRect
	{
	public Point p1;
	public Point p2;
	public bool visible;
	public bool drawing;
	public event selectRectEventHandler selectRectMsg;

	public SelectRect(Test2d t )
		{
		  p1.X = 0;
		  p1.Y = 0;
		  p2.X = 0;
		  p2.Y = 0;
		  visible = true;
		  this.selectRectMsg += new selectRectEventHandler(t.OnselectRect);

		}
	public void resetRect(int x, int y )
	{
		  p1.X = x;
		  p1.Y = y;
		  p2.X = x;
		  p2.Y = y;
		  visible = true;
		  drawing= true;
	}

	public void setRect(int x, int y )
	{
		  p2.X = x;
		  p2.Y = y;
		  visible = false;
		  drawing= false;
		if (selectRectMsg != null)
		{
			selectRectMsg(this, new selectRectEventArgs(p1,p2));
		}
	}


	public void undoRect(int x, int y , int x_f, int y_f)
	{
		  visible = false;
	}

 	}


	/// <summary>
	/// Test form 4 path.dll.
	/// </summary>
	public class Test2d : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel board2dPnl;
		private System.Windows.Forms.Panel commandPanl;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;

		//test
		Cartesio cart;
		Point P1 ;
		Point P2 ;
		super_path Np;
		Random r;
		SelectRect s_r;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button button4;


		public Test2d()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitWorld();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		private void InitWorld()
		{


			  //*****TEST
		cart = new Cartesio(600,600);
		cart.AddWall(30,30,30,110);
		cart.AddWall(100,70,10,170);

		cart.AddWall(50,50,30,10);
		cart.AddWall(44,44,25,10);

		cart.AddWall(56,56,100,10);
		cart.AddWall(156,15,11,231);
		cart.AddWall(10,135,114,26);

		cart.AddWall(70,80,35,10);
		cart.AddWall(105,75,25,10);
		cart.AddWall(115,106,50,10);
/*		cart.AddWall(119,177,40,15);
		cart.AddWall(118,125,15,15);
		cart.AddWall(75,106,10,10);*/

   /*		cart.AddWall(65,156,30,10);
		cart.AddWall(90,230,40,5);
		cart.AddWall(90,290,40,5);
		cart.AddWall(200,290,40,5);
		cart.AddWall(150,150,70,5);
		cart.AddWall(70,200,40,5);*/
//		cart.AddWall(40,180,40,5);
//		cart.AddWall(30,190,30,5);
//		cart.AddWall(25,210,50,5);
//		cart.AddWall(65,220,20,5);

		r = new Random();

		/*
		cart.Create_ai_nodes();
		P1 = new Point(11,10);
		P2 = new Point(100,250);
		Np = new super_path(P1,P2,cart);
		*/
		s_r = new SelectRect(this);

		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.board2dPnl = new System.Windows.Forms.Panel();
			this.commandPanl = new System.Windows.Forms.Panel();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.button3 = new System.Windows.Forms.Button();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.commandPanl.SuspendLayout();
			this.SuspendLayout();
			// 
			// board2dPnl
			// 
			this.board2dPnl.BackColor = System.Drawing.Color.White;
			this.board2dPnl.Location = new System.Drawing.Point(8, 24);
			this.board2dPnl.Name = "board2dPnl";
			this.board2dPnl.Size = new System.Drawing.Size(704, 320);
			this.board2dPnl.TabIndex = 0;
			this.board2dPnl.MouseUp += new System.Windows.Forms.MouseEventHandler(this.onPnlMouseUp);
			this.board2dPnl.Paint += new System.Windows.Forms.PaintEventHandler(this.onPaint);
			this.board2dPnl.MouseMove += new System.Windows.Forms.MouseEventHandler(this.onPnlMouseMove);
			this.board2dPnl.MouseDown += new System.Windows.Forms.MouseEventHandler(this.onMouseDown);
			// 
			// commandPanl
			// 
			this.commandPanl.Controls.Add(this.button4);
			this.commandPanl.Controls.Add(this.label4);
			this.commandPanl.Controls.Add(this.label3);
			this.commandPanl.Controls.Add(this.button3);
			this.commandPanl.Controls.Add(this.checkBox1);
			this.commandPanl.Controls.Add(this.label2);
			this.commandPanl.Controls.Add(this.label1);
			this.commandPanl.Controls.Add(this.button2);
			this.commandPanl.Controls.Add(this.button1);
			this.commandPanl.Location = new System.Drawing.Point(8, 352);
			this.commandPanl.Name = "commandPanl";
			this.commandPanl.Size = new System.Drawing.Size(704, 48);
			this.commandPanl.TabIndex = 1;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(456, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(104, 16);
			this.label4.TabIndex = 7;
			this.label4.Text = "#Arcs";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(456, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(112, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "#Nodes";
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(320, 8);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(104, 24);
			this.button3.TabIndex = 5;
			this.button3.Text = "Create AI Nodes";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(240, 16);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(80, 16);
			this.checkBox1.TabIndex = 4;
			this.checkBox1.Text = "Draw walls";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(640, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Y";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(640, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "X";
			// 
			// button2
			// 
			this.button2.Enabled = false;
			this.button2.Location = new System.Drawing.Point(128, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(88, 24);
			this.button2.TabIndex = 1;
			this.button2.Text = "Simulation";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button1
			// 
			this.button1.Enabled = false;
			this.button1.Location = new System.Drawing.Point(8, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(104, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Go!";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(560, 8);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(56, 24);
			this.button4.TabIndex = 8;
			this.button4.Text = "Clear";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// Test2d
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(720, 400);
			this.Controls.Add(this.commandPanl);
			this.Controls.Add(this.board2dPnl);
			this.Name = "Test2d";
			this.Text = "Test - 2d";
			this.commandPanl.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new Test2d());
		}

		private void onPaint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		redraw();
		}

		public void OnselectRect(object sender, selectRectEventArgs e)
		{
			//cart.AddWall(e.p1.X ,e.p1.Y,e.p2.X-e.p1.X,e.p2.Y-e.p1.Y);
			cart.AddWall(e.p1,e.p2);
		}

		private void onPnlMouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		if (checkBox1.Checked)
		{
				s_r.setRect(e.X,e.Y);
		}
		else
		{
		 if (e.Button.ToString() == "Right")
		 {
			P1.X = e.X;
			P1.Y = e.Y;
			Np = new super_path(P1,P2,cart);
		 }
		 else
		 {
			//P1 = new Point(20,10);
			P2.X = e.X;
			P2.Y = e.Y;
			Np = new super_path(P1,P2,cart);
			if (e.Clicks == 1)
			{
				Go();
			}
		  }
         }
			redraw();
		}

		private void onPnlMouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
					label1.Text = e.X.ToString();
					label2.Text = e.Y.ToString();

				  if (checkBox1.Checked)
					if (s_r.drawing)
					{
						s_r.p2.X = e.X;
						s_r.p2.Y = e.Y;
						redraw();
					}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{

		if (button2.Text == "Stop")
		{
			button2.Text = "Simulate";
			button2.Tag = "stop";
		}
		else
		{
		button2.Text = "Stop";
		button2.Tag = "";


		for (int i = 0;  i < 2000 ;i++ )
		{
			if ((string)button2.Tag == "stop")
				i = 2000;
			P1.X = (int) (r.NextDouble() * 250);
			P1.Y = (int) (r.NextDouble() * 250);
			P2.X = (int) (r.NextDouble() * 250);
			P2.Y = (int) (r.NextDouble() * 250);
			Console.WriteLine( " P1 " + P1 + " P2 " + P2 );
			Np = new super_path(P1,P2,cart);
			int j = 0;
			while (!Np.Next())
			{
				P1 = Np.Pa;
				if (j ==6)
				{
					j = 0;
					Application.DoEvents();
					redraw();
				}
				j++;

			}
			label1.Text = i.ToString();
				redraw();
		}
		}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Go();
		}

		private void Go()
		{
			int j = 0;
			while (!Np.Next())
			{
				P1 = Np.Pa;
				//this.Refresh();
				Application.DoEvents();
				if (j ==6)
				{
					j = 0;
					redraw();
				}
				j++;
			}
				redraw();

		}

		private void redraw()
		{
			Rectangle rect;
			Graphics g = board2dPnl.CreateGraphics();

			//Do Double Buffering
			Bitmap offScreenBmp;
			Graphics offScreenDC;
			offScreenBmp = new Bitmap(board2dPnl.Width, board2dPnl.Height);
			offScreenDC = Graphics.FromImage(offScreenBmp);

			offScreenDC.Clear(board2dPnl.BackColor);
			//offScreenDC.SmoothingMode=SmoothingMode.AntiAlias;


			foreach (Wall w in cart.walls)
			{
				//myGraphics.DrawRectangle(new Pen(Color.Black, 1), w.X, w.Y, w.Wid, w.Hei	);
				rect = new Rectangle(w.X,w.Y,w.Wid,w.Hei);
				offScreenDC.FillRectangle(Brushes.Goldenrod,rect);

				//GraphicsPath path=new GraphicsPath();
				//path.AddEllipse(rect);
				//PathGradientBrush pgbrush= new PathGradientBrush(path);
				//pgbrush.CenterPoint=new Point((rect.Right- rect.Left) /3+rect.Left,(rect.Bottom - rect.Top) /3+rect.Top);
				//pgbrush.CenterColor=Color.White;
				//pgbrush.SurroundColors=new Color[] { Color.Red };
				//offScreenDC.FillRectangle(pgbrush,rect);
				//offScreenDC.DrawEllipse(new Pen(Color.Red),rect);

			}

			foreach (Node p in cart.ai_nodes)
			{
				rect = new Rectangle(p.P.X,p.P.Y,1,1);
				offScreenDC.FillRectangle(Brushes.Red,rect);
				offScreenDC.DrawEllipse(new Pen(Color.Black, 1),p.P.X-3,p.P.Y-3,6,6);
			}

			rect = new Rectangle(P1.X,P1.Y,2,2);
			offScreenDC.FillRectangle(Brushes.Blue,rect);
			offScreenDC.DrawEllipse(new Pen(Color.Blue, 1),P1.X-3,P1.Y-3,6,6);
			rect = new Rectangle(P2.X,P2.Y,2,2);
			offScreenDC.DrawEllipse(new Pen(Color.Red, 1),P2.X-3,P2.Y-3,6,6);
			offScreenDC.FillRectangle(Brushes.Blue,rect);

			if (s_r.visible)
			{
				// offScreenDC.DrawRectangle(new Pen(Color.Black, 1),s_r.p1.X,s_r.p1.Y,s_r.p2.X - s_r.p1.X,s_r.p2.Y - s_r.p1.Y);
				offScreenDC.DrawLine(new Pen(Color.Black, 1),s_r.p1.X,s_r.p1.Y,s_r.p1.X,s_r.p2.Y);
				offScreenDC.DrawLine(new Pen(Color.Black, 1),s_r.p1.X,s_r.p2.Y,s_r.p2.X,s_r.p2.Y);
				offScreenDC.DrawLine(new Pen(Color.Black, 1),s_r.p2.X,s_r.p2.Y,s_r.p2.X,s_r.p1.Y);
				offScreenDC.DrawLine(new Pen(Color.Black, 1),s_r.p2.X,s_r.p1.Y,s_r.p1.X,s_r.p1.Y);
			}

			g.DrawImageUnscaled(offScreenBmp, 0, 0);
		}

		private void onMouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		if (checkBox1.Checked)
			s_r.resetRect(e.X,e.Y);
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
		button1.Enabled = false;
		button2.Enabled = false;

		cart.Clear_ai_nodes();
		cart.Create_ai_nodes();
		P1 = new Point(11,10);
		P2 = new Point(100,250);
		Np = new super_path(P1,P2,cart);

		// Debug--statistics
		label3.Text = "N. nodes " + cart.ai_nodes.Count.ToString();
		int n_arcs =0;
		foreach (Node p in cart.ai_nodes)
		{
		  n_arcs = n_arcs + p.arcs.Count;
		}
		label4.Text = "N. nodes " + n_arcs.ToString();
		// Debug--statistics

		redraw();
		checkBox1.Checked = false;
		button1.Enabled = true;
		button2.Enabled = true;
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{

		}
		
		private void button4_Click(object sender, System.EventArgs e)
		{
			cart.Clear_ai_nodes();
			cart.walls.Clear();
			redraw();
		}



	}
}
